CREATE TABLE VEHICLE (VIN VARCHAR(255) NOT NULL, MAKE VARCHAR(255), MODEL VARCHAR(255), VERSION INTEGER, MODEL_YEAR INTEGER, PRIMARY KEY (VIN))
CREATE TABLE ADDRESS (ADDRESS_ID_PK INTEGER NOT NULL, CITY VARCHAR(255), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), STATE VARCHAR(255), STREET VARCHAR(255), UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ZIP VARCHAR(5) NOT NULL, PRIMARY KEY (ADDRESS_ID_PK))
CREATE TABLE ADDRESS2 (ZIP_PK VARCHAR(255) NOT NULL, STREET_PK VARCHAR(255) NOT NULL, CITY VARCHAR(255), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), STATE VARCHAR(255), UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, PRIMARY KEY (ZIP_PK, STREET_PK))
CREATE TABLE BOOK (BOOK_ID_PK INTEGER NOT NULL, AUTHOR VARCHAR(255), BOOK_CREATE_TIME TIMESTAMP, BOOK_CREATE_USER VARCHAR(255), ISBN VARCHAR(255), OUT_OF_PRINT VARCHAR(255), PRICE FLOAT, RATING INTEGER, TITLE VARCHAR(255), BOOK_UPDATE_TIME TIMESTAMP, BOOK_UPDATE_USER VARCHAR(255), VERSION INTEGER, PRIMARY KEY (BOOK_ID_PK))
CREATE TABLE CONTENT (BOOK_ID_FPK INTEGER NOT NULL, PDF BLOB NOT NULL, PRIMARY KEY (BOOK_ID_FPK))
CREATE TABLE CATEGORY (CATEGORY_ID_PK INTEGER NOT NULL, CATEGORY_NAME VARCHAR(255), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, PARENT_CATEGORY_FK INTEGER, PRIMARY KEY (CATEGORY_ID_PK))
CREATE TABLE PHONE (PHONE_ID_PK INTEGER NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), PHONE_NUMBER VARCHAR(255), PHONE_TYPE VARCHAR(255), UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, CUSTOMER_ID_FK INTEGER, PRIMARY KEY (PHONE_ID_PK))
CREATE TABLE CUSTOMER (CUSTOMER_ID_PK INTEGER NOT NULL, CUSTOMER_TYPE VARCHAR(1), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), INCOME FLOAT, NAME VARCHAR(255), PICTURE BLOB NOT NULL, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ACCOUNT_NUMBER VARCHAR(255), BANK_NAME VARCHAR(255), ROUTING_NUMBER VARCHAR(255), ADDRESS_ID_FK INTEGER, PRIMARY KEY (CUSTOMER_ID_PK))
CREATE TABLE CUST_PICTURE (CUSTOMER_ID_FPK INTEGER NOT NULL, PICTURE BLOB NOT NULL, PRIMARY KEY (CUSTOMER_ID_FPK))
CREATE TABLE CUSTOMER2 (CUSTOMER_ID_PK INTEGER NOT NULL, CUSTOMER_TYPE VARCHAR(1), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), INCOME FLOAT, NAME VARCHAR(255), PICTURE BLOB NOT NULL, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ACCOUNT_NUMBER VARCHAR(255), BANK_NAME VARCHAR(255), ROUTING_NUMBER VARCHAR(255), ADDRESS_ID_FK INTEGER, CARD_NUMBER VARCHAR(255), CREDIT_LIMIT FLOAT, DISCOUNT_RATE FLOAT, EXPIRATION_DATE DATE, PRIMARY KEY (CUSTOMER_ID_PK))
CREATE TABLE CUSTOMER3 (CUSTOMER_ID_PK INTEGER NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), INCOME FLOAT, NAME VARCHAR(255), PICTURE BLOB NOT NULL, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ACCOUNT_NUMBER VARCHAR(255), BANK_NAME VARCHAR(255), ROUTING_NUMBER VARCHAR(255), ADDRESS_ID_FK INTEGER, PRIMARY KEY (CUSTOMER_ID_PK))
CREATE TABLE CUSTOMER5 (CUSTOMER_ID_PK INTEGER NOT NULL, CUSTOMER_TYPE VARCHAR(1), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), INCOME FLOAT, NAME VARCHAR(255), PICTURE BLOB NOT NULL, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ACCOUNT_NUMBER VARCHAR(255), BANK_NAME VARCHAR(255), ROUTING_NUMBER VARCHAR(255), ZIP_FK VARCHAR(255), STREET_FK VARCHAR(255), PRIMARY KEY (CUSTOMER_ID_PK))
CREATE TABLE GOLD_CUSTOMER (CUSTOMER_ID_FPK INTEGER NOT NULL, CARD_NUMBER VARCHAR(255), CREDIT_LIMIT FLOAT, PRIMARY KEY (CUSTOMER_ID_FPK))
CREATE TABLE GOLD_CUSTOMER3 (CUSTOMER_ID_PK INTEGER NOT NULL, CARD_NUMBER VARCHAR(255), CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), CREDIT_LIMIT FLOAT, INCOME FLOAT, NAME VARCHAR(255), PICTURE BLOB NOT NULL, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ACCOUNT_NUMBER VARCHAR(255), BANK_NAME VARCHAR(255), ROUTING_NUMBER VARCHAR(255), ADDRESS_ID_FK INTEGER, PRIMARY KEY (CUSTOMER_ID_PK))
CREATE TABLE GOLD_CUSTOMER5 (CUSTOMER_ID_FPK INTEGER NOT NULL, CARD_NUMBER VARCHAR(255), CREDIT_LIMIT FLOAT, PRIMARY KEY (CUSTOMER_ID_FPK))
CREATE TABLE LINE_ITEM (LINE_ITEM_ID_PK INTEGER NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), PRICE FLOAT, QUANTITY INTEGER, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, BOOK_ID_FK INTEGER, ORDER_ID_FK INTEGER, LINE_ITEM_ID_PK INTEGER NOT NULL, PRIMARY KEY (LINE_ITEM_ID_PK, LINE_ITEM_ID_PK))
CREATE TABLE ORDERS (ORDER_ID_PK INTEGER NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), ORDER_TIME TIMESTAMP, PRICE FLOAT, STATUS INTEGER, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, CUSTOMER_ID_FK INTEGER, PRIMARY KEY (ORDER_ID_PK))
CREATE TABLE PREFERRED_CUSTOMER (CUSTOMER_ID_FPK INTEGER NOT NULL, DISCOUNT_RATE FLOAT, EXPIRATION_DATE DATE, PRIMARY KEY (CUSTOMER_ID_FPK))
CREATE TABLE PREFERRED_CUSTOMER3 (CUSTOMER_ID_PK INTEGER NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), DISCOUNT_RATE FLOAT, EXPIRATION_DATE DATE, INCOME FLOAT, NAME VARCHAR(255), PICTURE BLOB NOT NULL, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ACCOUNT_NUMBER VARCHAR(255), BANK_NAME VARCHAR(255), ROUTING_NUMBER VARCHAR(255), ADDRESS_ID_FK INTEGER, PRIMARY KEY (CUSTOMER_ID_PK))
CREATE TABLE PREFERRED_CUSTOMER5 (CUSTOMER_ID_FPK INTEGER NOT NULL, DISCOUNT_RATE FLOAT, EXPIRATION_DATE DATE, PRIMARY KEY (CUSTOMER_ID_FPK))
CREATE TABLE APARTMENT (APT_NUM_PK SMALLINT NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), NUM_ROOMS SMALLINT, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ADDRESS_ID_FPK INTEGER NOT NULL, PRIMARY KEY (APT_NUM_PK, ADDRESS_ID_FPK))
CREATE TABLE APARTMENT2 (APT_NUM_PK SMALLINT NOT NULL, CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), NUM_ROOMS SMALLINT, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ZIP_FPK VARCHAR(255) NOT NULL, STREET_FPK VARCHAR(255) NOT NULL, PRIMARY KEY (APT_NUM_PK, ZIP_FPK, STREET_FPK))
CREATE TABLE HOUSE (CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), NUM_ROOMS SMALLINT, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ADDRESS_ID_FPK INTEGER NOT NULL, PRIMARY KEY (ADDRESS_ID_FPK))
CREATE TABLE HOUSE2 (CREATE_TIME TIMESTAMP, CREATE_USER VARCHAR(255), NUM_ROOMS SMALLINT, UPDATE_TIME TIMESTAMP, UPDATE_USER VARCHAR(255), VERSION INTEGER, ZIP_FPK VARCHAR(255) NOT NULL, STREET_FPK VARCHAR(255) NOT NULL, PRIMARY KEY (ZIP_FPK, STREET_FPK))
CREATE TABLE BOOK_CATEGORY (BOOK_ID_FPK INTEGER NOT NULL, CATEGORY_ID_FPK INTEGER NOT NULL, PRIMARY KEY (BOOK_ID_FPK, CATEGORY_ID_FPK))
CREATE TABLE CUST_BANK (BANK_ACCOUNT_NUMBER VARCHAR(255), BANK_NAME_X VARCHAR(255), BANK_ROUTING_NUMBER VARCHAR(255), CUST_ID_FPK INTEGER)
CREATE TABLE CUST_NICKNAME (CUST_ID_FPK INTEGER, NICKNAMES VARCHAR(255))
ALTER TABLE CONTENT ADD CONSTRAINT CONTENTBOOK_ID_FPK FOREIGN KEY (BOOK_ID_FPK) REFERENCES BOOK (BOOK_ID_PK)
ALTER TABLE CATEGORY ADD CONSTRAINT CTGRYPRNTCTEGORYFK FOREIGN KEY (PARENT_CATEGORY_FK) REFERENCES CATEGORY (CATEGORY_ID_PK)
ALTER TABLE PHONE ADD CONSTRAINT PHONECUSTOMERID_FK FOREIGN KEY (CUSTOMER_ID_FK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
ALTER TABLE CUSTOMER ADD CONSTRAINT CUSTOMERDDRESSIDFK FOREIGN KEY (ADDRESS_ID_FK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE CUST_PICTURE ADD CONSTRAINT CSTPCTRECSTMRIDFPK FOREIGN KEY (CUSTOMER_ID_FPK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
ALTER TABLE CUSTOMER2 ADD CONSTRAINT CSTOMER2DDRESSIDFK FOREIGN KEY (ADDRESS_ID_FK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE CUSTOMER3 ADD CONSTRAINT CSTOMER3DDRESSIDFK FOREIGN KEY (ADDRESS_ID_FK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE CUSTOMER5 ADD CONSTRAINT CUSTOMER5_ZIP_FK FOREIGN KEY (ZIP_FK, STREET_FK) REFERENCES ADDRESS2 (ZIP_PK, STREET_PK)
ALTER TABLE GOLD_CUSTOMER ADD CONSTRAINT GLDCSTMERCSTMRDFPK FOREIGN KEY (CUSTOMER_ID_FPK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
ALTER TABLE GOLD_CUSTOMER3 ADD CONSTRAINT GLDCSTMER3DDRSSDFK FOREIGN KEY (ADDRESS_ID_FK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE GOLD_CUSTOMER5 ADD CONSTRAINT GLDCSTMR5CSTMRDFPK FOREIGN KEY (CUSTOMER_ID_FPK) REFERENCES CUSTOMER5 (CUSTOMER_ID_PK)
ALTER TABLE LINE_ITEM ADD CONSTRAINT LINEITEMBOOK_ID_FK FOREIGN KEY (BOOK_ID_FK) REFERENCES BOOK (BOOK_ID_PK)
ALTER TABLE LINE_ITEM ADD CONSTRAINT LINEITEMORDERID_FK FOREIGN KEY (ORDER_ID_FK) REFERENCES ORDERS (ORDER_ID_PK)
ALTER TABLE ORDERS ADD CONSTRAINT ORDERSCUSTOMERIDFK FOREIGN KEY (CUSTOMER_ID_FK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
ALTER TABLE PREFERRED_CUSTOMER ADD CONSTRAINT PRFRRDCSTCSTMRDFPK FOREIGN KEY (CUSTOMER_ID_FPK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
ALTER TABLE PREFERRED_CUSTOMER3 ADD CONSTRAINT PRFRRDCSTMDDRSSDFK FOREIGN KEY (ADDRESS_ID_FK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE PREFERRED_CUSTOMER5 ADD CONSTRAINT PRFRRDCSTCSTMRDFPK FOREIGN KEY (CUSTOMER_ID_FPK) REFERENCES CUSTOMER5 (CUSTOMER_ID_PK)
ALTER TABLE APARTMENT ADD CONSTRAINT PRTMENTDDRESSIDFPK FOREIGN KEY (ADDRESS_ID_FPK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE APARTMENT2 ADD CONSTRAINT APARTMENT2_ZIP_FPK FOREIGN KEY (ZIP_FPK, STREET_FPK) REFERENCES ADDRESS2 (ZIP_PK, STREET_PK)
ALTER TABLE HOUSE ADD CONSTRAINT HOUSEADDRESSID_FPK FOREIGN KEY (ADDRESS_ID_FPK) REFERENCES ADDRESS (ADDRESS_ID_PK)
ALTER TABLE HOUSE2 ADD CONSTRAINT FK_HOUSE2_ZIP_FPK FOREIGN KEY (ZIP_FPK, STREET_FPK) REFERENCES ADDRESS2 (ZIP_PK, STREET_PK)
ALTER TABLE BOOK_CATEGORY ADD CONSTRAINT BKCTGORYCTGRYIDFPK FOREIGN KEY (CATEGORY_ID_FPK) REFERENCES CATEGORY (CATEGORY_ID_PK)
ALTER TABLE BOOK_CATEGORY ADD CONSTRAINT BKCATEGORYBOKIDFPK FOREIGN KEY (BOOK_ID_FPK) REFERENCES BOOK (BOOK_ID_PK)
ALTER TABLE CUST_BANK ADD CONSTRAINT CUSTBANKCUSTID_FPK FOREIGN KEY (CUST_ID_FPK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
ALTER TABLE CUST_NICKNAME ADD CONSTRAINT CSTNICKNAMECSTDFPK FOREIGN KEY (CUST_ID_FPK) REFERENCES CUSTOMER (CUSTOMER_ID_PK)
CREATE TABLE SEQUENCE_GENERATOR_TB (SEQUENCE_NAME VARCHAR(50) NOT NULL, SEQUENCE_VALUE DECIMAL(15), PRIMARY KEY (SEQUENCE_NAME))
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('ORDERS_SEQ', 0)
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('CATEGORY_SEQ', 0)
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('CUSTOMER_SEQ', 0)
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('PHONE_SEQ', 0)
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('LINE_ITEM_SEQ', 0)
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('ADDRESS_SEQ', 0)
INSERT INTO SEQUENCE_GENERATOR_TB(SEQUENCE_NAME, SEQUENCE_VALUE) values ('BOOK_SEQ', 0)
